Bug 782220 - Review Request: dlm - cluster infrastructure for dlm (distributed lock manager)
Review Request: dlm - cluster infrastructure for dlm (distributed lock manager)
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Steven Dake
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-01-16 16:09 EST by David Teigland
Modified: 2016-04-26 12:12 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-02-01 02:31:36 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
sdake: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
patch to change spaces to tabs in header (1.01 KB, patch)
2012-01-26 14:05 EST, Steven Dake
no flags Details | Diff

  None (edit)
Description David Teigland 2012-01-16 16:09:35 EST
Spec URL: http://people.redhat.com/teigland/dlm.spec
SRPM URL: http://people.redhat.com/teigland/dlm-3.9.0-1.fc15.src.rpm
Description: The kernel dlm requires this userland daemon to manage membership.
Comment 1 Steven Dake 2012-01-16 16:32:34 EST
BuildRoot is no longer required in fedora packages.  It is defined by the build system.

clean section is no longer required in fedora packages.  clean happens automatically in fedora build system.

Fedora packages should not use ExclusiveArch unless the package absolutely won't build on other architectures
Comment 2 Steven Dake 2012-01-16 16:39:40 EST
BLOCKER: rpmbuild -ba dlm.spec fails:

+ /usr/lib/rpm/check-buildroot
+ /usr/lib/rpm/redhat/brp-compress
+ /usr/lib/rpm/redhat/brp-strip-static-archive /usr/bin/strip
+ /usr/lib/rpm/brp-python-bytecompile /usr/bin/python 1
+ /usr/lib/rpm/redhat/brp-python-hardlink
+ /usr/lib/rpm/redhat/brp-java-repack-jars
Processing files: dlm-3.9.0-1.fc16.x86_64
error: File not found: /root/rpmbuild/BUILDROOT/dlm-3.9.0-1.fc16.x86_64/lib/systemd/system/dlm.service


RPM build errors:
    File not found: /root/rpmbuild/BUILDROOT/dlm-3.9.0-1.fc16.x86_64/lib/systemd/system/dlm.service

dlm.service is in the dlm_controld directory but I don't see how the Makefile installs the package.

I'd also encourage you if you do a new release to include a LICENSE file in the top level working directory and place it in the RPM.
Comment 3 David Teigland 2012-01-16 17:16:48 EST
new spec and src in same places should fix those
Comment 4 David Teigland 2012-01-17 10:32:23 EST
fixed a few more things, rpmbuild -ba now works for me
Comment 5 Steven Dake 2012-01-17 11:08:58 EST
When updating packages please bump the version release number and post new links so an upgrade works properly.

[FAIL] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.[1] 

[sdake@beast SRPMS]$ rpmlint dlm-3.9.0-1.fc16.src.rpm
dlm.src: W: summary-not-capitalized C cluster infrastructure for dlm (distributed lock manager)
dlm.src: W: name-repeated-in-summary C dlm
dlm.src: W: spelling-error %description -l en_US userland -> user land, user-land, slanderous
dlm.src: W: invalid-license GPLv2, GPLv2+, LGPLv2+
dlm.src: W: invalid-url Source0: https://fedorahosted.org/releases/d/l/dlm/dlm-3.9.0.tar.gz HTTP Error 404: Not Found
1 packages and 0 specfiles checked; 0 errors, 5 warnings.

Recommend capitalizing summary
Recommend changing userland to user land
Recommend changing license to "GPLv2+" (this covers v2)
Recommend making source code available

[sdake@beast x86_64]$ rpmlint dlm-3.9.0-1.fc16.x86_64.rpm
dlm.x86_64: W: summary-not-capitalized C cluster infrastructure for dlm (distributed lock manager)
dlm.x86_64: W: name-repeated-in-summary C dlm
dlm.x86_64: W: spelling-error %description -l en_US userland -> user land, user-land, slanderous
dlm.x86_64: W: invalid-license GPLv2, GPLv2+, LGPLv2+
dlm.x86_64: E: script-without-shebang /lib/systemd/system/dlm.service
dlm.x86_64: E: postin-without-chkconfig /etc/rc.d/init.d/dlm
dlm.x86_64: E: preun-without-chkconfig /etc/rc.d/init.d/dlm
dlm.x86_64: W: service-default-enabled /etc/rc.d/init.d/dlm
dlm.x86_64: E: no-chkconfig-line /etc/rc.d/init.d/dlm
dlm.x86_64: E: subsys-not-used /etc/rc.d/init.d/dlm
1 packages and 0 specfiles checked; 5 errors, 5 warnings.

Recommend capitalizing Cluster
Recommend changing userland to user land
Recommend changing license to GPLV2+
/etc/rc.d/init.d/dlm should not be shipped in new fedora packages
/etc/rc.d/init.d/dlm conflicts with /lib/systemd/system/dlm.service
chkconfig warnings can be ignored
looks like rpmlint needs fixing for systemd

[root@beast x86_64]# rpmlint dlm-debuginfo
dlm-debuginfo.x86_64: W: invalid-license GPLv2, GPLv2+, LGPLv2+
dlm-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/dlm-3.9.0/dlm_controld/rbtree.c
dlm-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/dlm-3.9.0/dlm_controld/rbtree.h
1 packages and 0 specfiles checked; 2 errors, 1 warnings.

Correct the mailing address of rbtree.h
[root@beast x86_64]# rpmlint dlm-devel-3.9.0-1.fc16.x86_64.rpm
dlm-devel.x86_64: W: no-dependency-on dlm/dlm-libs/libdlm
dlm-devel.x86_64: W: invalid-license GPLv2, GPLv2+, LGPLv2+
dlm-devel.x86_64: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

what originates dlm/dlm-libs/libdlm?
Change license to GPLv2+
ignore no documentation warning

I highly recommend requesting upstream (you?) to include a license file (IE put in COPYING in the tarball) and include it in all of the RPMS as a %doc section.

[PASS] MUST: The package must be named according to the Package Naming Guidelines .

[PASS] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] . 

[FAIL] MUST: The package must meet the Packaging Guidelines .

Multiple issues found with rpmlint.  init.d scripts included in new fedora packages is highly discouraged.  Conflict with init.d and systemd needs resolution.  Once those are addressed the package would meet guidelines.

[PASS] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .

[PASS] MUST: The License field in the package spec file must match the actual license. [3]

[PASS] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]

Please request upstream to include a license file in the package.  Ideally all fedora packages should ship the license as a file in every rpm.

[PASS] MUST: The spec file must be written in American English. [5]

[PASS] MUST: The spec file for the package MUST be legible. [6]

[FAIL] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

Sources are not upstream.

[PASS] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]

builds on x86_64 architecture

[N/A] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]

[PASS] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.

[N/A] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]

[PASS] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]

[PASS] MUST: Packages must NOT bundle copies of system libraries.[11]

[N/A] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [12]

[PASS] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [13]
[PASS] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)[14]

[PASS] MUST: Permissions on files must be set properly. Executables should be set with 
executable permissions, for example. [15]

[PASS] MUST: Each package must consistently use macros. [16]

[PASS] MUST: The package must contain code, or permissable content. [17]

[N/A] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]

[N/A] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]

[PASS] MUST: Header files must be in a -devel package. [19]

[N/A] MUST: Static libraries must be in a -static package. [20]

[PASS] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. [19]

[NOTSURE] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release} [21]

I think devel should depend on %{name} not %{name}-lib.  I'll do more research and get back to you on this point.

[PASS] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[20]

[N/A] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [22]

[PASS] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [23]

[PASS] MUST: All filenames in rpm packages must be valid UTF-8. [24]
Comment 6 David Teigland 2012-01-18 13:47:39 EST
more changes, rpmlint now tells me:

dlm.src: W: invalid-license GPLv2, GPLv2+, LGPLv2+

That's the license, take it or leave it.

dlm.src:35: E: hardcoded-library-path in %{buildroot}/lib/systemd/systemd-dlm
dlm.src:58: E: hardcoded-library-path in /lib/systemd/systemd-dlm

This is the only way I found to do this (%{_lib} is not correct here AFAICT)

dlm.src: W: invalid-url Source0: https://fedorahosted.org/releases/d/l/dlm/dlm-3.9.0.tar.gz 

Will upload once final.
Comment 7 Steven Dake 2012-01-18 14:36:39 EST
post an updated spec and rpm and I'll have a look at the changes.

Regards
-steve
Comment 9 Steven Dake 2012-01-19 17:06:24 EST
tibbs pointed me at this link re the spec file license:
https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#Multiple_Licensing_Scenarios
Comment 10 Steven Dake 2012-01-23 14:33:38 EST
Rather then just changing the spec file, can you build a new SRPM?  Make sure to bump 
the Release field (ie: 1%{?dist} to 2%{?dist} and edit the changelog.

Change the BuildRequires for corosync to:

BuildRequires: corosync >= 1.99.0

Since this requires the corosync 1.99.0 headers to build, I can't approve this package until corosync alpha is in rawhide (or the dlm package won't build and trigger a bunch of spam email).  Honza will be putting it in shortly.


[root@beast SRPMS]# rpmlint dlm*src.rpm
dlm.src:36: E: hardcoded-library-path in %{buildroot}/lib/systemd/systemd-dlm
dlm.src:59: E: hardcoded-library-path in /lib/systemd/systemd-dlm
dlm.src: W: invalid-url Source0: https://fedorahosted.org/releases/d/l/dlm/dlm-3.9.0.tar.gz HTTP Error 404: Not Found
1 packages and 0 specfiles checked; 2 errors, 1 warnings.

/lib/systemd/systemd-dlm seems invalid to me.  It is an init script.  Init scripts are not needed in fedora 16+.  /lib/systemd binaries are meant as support binaries for the systemd package.  This is why there are E returns for the lib/systemd definition.

The source must be posted and have an upstream before it can be merged into fedora.

The following things are currently in the FAIL state:
1. systemd-dlm should be removed (does this help the software function?)
2. no upstream sources
3. the sources in the src.rpm must match the upstream sources
4. The BuildRequires is commented out, blocking merging of the package

This package depends on the corosync alpha package, which hasn't been merged.  Please address the other issues, post a new spec and srpm, and I'll finish the review.  Then when Honza merges the new corosync, I can approve.
Comment 11 David Teigland 2012-01-23 15:13:04 EST
> BuildRequires: corosync >= 1.99.0

ok

> 1. systemd-dlm should be removed (does this help the software function?)

This is how I was told to use init scripts with systemd (until I have the time to develop an equivalent script-less method.)

None of the other comments can be done until there's a real release and build to do... which I'll do once it's approved, and once a corosync package exists.
Comment 12 David Teigland 2012-01-24 14:13:43 EST
I've done a final release, location in new spec file.

I've switched to standard service file, the missing bits from the init file can be someone else's problem.
Comment 14 Steven Dake 2012-01-26 14:03:49 EST
The first section uses mixed tabs and spaces.  I've attached a patch to fix.  Please integrate that patch to the spec file.

with patch:

[root@beast SRPMS]# rpmlint dlm-3.99.0-1.fc16.src.rpm
dlm.src:3: W: mixed-use-of-spaces-and-tabs (spaces: line 3, tab: line 1)
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

[root@beast x86_64]# rpmlint dlm-3.99.0-1.fc16.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
[root@beast x86_64]# rpmlint dlm-debuginfo-3.99.0-1.fc16.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
[root@beast x86_64]# rpmlint dlm-devel-3.99.0-1.fc16.x86_64.rpm
dlm-devel.x86_64: W: no-dependency-on dlm/dlm-libs/libdlm
dlm-devel.x86_64: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 2 warnings.
[root@beast x86_64]# rpmlint dlm-lib-3.99.0-1.fc16.x86_64.rpm
dlm-lib.x86_64: W: spelling-error %description -l en_US userland -> user land, user-land, slanderous
dlm-lib.x86_64: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

I would recommend changing userland to "user-land" or "user land"

Please put README.license in a %doc of the files section of dlm-devel

[PASS] MUST: The sources used to build the package must match the upstream
source, as provided in the spec URL. Reviewers should use md5sum for this task.
If no upstream URL can be specified for this package, please see the Source URL
Guidelines for how to deal with this.

[root@beast SPECS]# wget http://people.redhat.com/teigland/dlm-3.99.0.tar.gz
--2012-01-26 11:59:04--  http://people.redhat.com/teigland/dlm-3.99.0.tar.gz
Resolving people.redhat.com... 10.5.19.30
Connecting to people.redhat.com|10.5.19.30|:80... connected.
HTTP request sent, awaiting response... 200 OK
Length: 95490 (93K) [application/x-gzip]
Saving to: “dlm-3.99.0.tar.gz”

100%[======================================>] 95,490       148K/s   in 0.6s    

2012-01-26 11:59:05 (148 KB/s) - “dlm-3.99.0.tar.gz” saved [95490/95490]

[root@beast SPECS]# sha256sum dlm-3.99.0.tar.gz
2c21065a6eac6a2ce24b3121aab0e9cf2dfce7ed15133b34ffdc0d98e2af47d5  dlm-3.99.0.tar.gz

[root@beast SOURCES]# sha256sum dlm-3.99.0.tar.gz
2c21065a6eac6a2ce24b3121aab0e9cf2dfce7ed15133b34ffdc0d98e2af47d5  dlm-3.99.0.tar.gz

To address before fedora-review+:
include readme.license in the %doc section of the devel package
apply patch to spec file to fix tabs/spaces issue in the header
Comment 15 Steven Dake 2012-01-26 14:05:33 EST
Created attachment 557729 [details]
patch to change spaces to tabs in header
Comment 16 Steven Dake 2012-01-27 13:15:09 EST
Package APPROVED.

Fabio,

Dave updated the remaining issues and updated the rpm in place.  Since he is on PTO for a couple weeks, can you take care of submitting the SCM request and executing the cluster stack transition at your leisure?

Thanks
Comment 17 Fabio Massimo Di Nitto 2012-01-30 03:02:57 EST
New Package SCM Request
=======================
Package Name: dlm
Short Description: dlm - cluster infrastructure for dlm (distributed lock manager)
Owners: teigland fabbione
Branches: 
InitialCC:
Comment 18 Jon Ciesla 2012-01-30 08:29:27 EST
teigland is not a valid packager member.
Comment 19 Steven Dake 2012-01-30 08:46:56 EST
Jon,

I am sponsoring teigland through this bugzilla.  I had failed to add him to the appropriate group.  This should be resolved now.  Apologies for the error.
Comment 20 Fabio Massimo Di Nitto 2012-01-30 08:53:00 EST
New Package SCM Request
=======================
Package Name: dlm
Short Description: dlm - cluster infrastructure for dlm (distributed lock
manager)
Owners: teigland fabbione
Branches: 
InitialCC:
Comment 21 Fabio Massimo Di Nitto 2012-01-30 08:53:19 EST
resubmitting the SCM request...
Comment 22 Jon Ciesla 2012-01-30 10:37:31 EST
Git done (by process-git-requests).

Excellent, thanks!

Note You need to log in before you can comment on or make changes to this bug.